#include <stdio.h>
#include <stdlib.h>

enum stitch_type { KNIT, PURL, INCREASE, DECREASE, CO };

struct stitch {
  int right_side;
  int count;
  enum stitch_type type;
  struct stitch* next;
  struct stitch* prev;
  struct stitch* next_row;
  struct stitch* prev_row;
};

struct stitch* curr;
struct stitch* prev_row;
int i, repeat;
void make_stitch(enum stitch_type type) {
  struct stitch* new_stitch =
      (struct stitch*) malloc(sizeof(struct stitch));
  new_stitch->type = type;
  new_stitch->next_row = NULL;
  new_stitch->next = NULL;
  new_stitch->prev = curr;
  int count = 1;
  if (curr != NULL) {
    curr->next = new_stitch;
    count = curr->count + 1;
  }
  new_stitch->count = count;
  new_stitch->prev_row = prev_row;
  if (prev_row != NULL) {
    prev_row->next_row = new_stitch;
    prev_row = prev_row->prev;
  }
  curr = new_stitch;
}
void print_stitch_symbol(enum stitch_type type, int rs) {
char symbol = 'x';
if ((type == KNIT && rs) || (type == PURL && !rs)) { symbol = '.'; }
if ((type == PURL && rs) || (type == KNIT && !rs)) { symbol = '~'; }
if (type == INCREASE) { symbol = 'v'; }
if (type == DECREASE) { symbol = '/'; }
if (type == CO) { symbol = '_'; }
printf("%c ", symbol);
}void wsRib() {
for (i=0;i<1;i++){make_stitch(PURL);}do {for (i=0;i<1;i++){make_stitch(KNIT);}
for (i=0;i<1;i++){make_stitch(PURL);}}while(prev_row!=NULL && prev_row->count!=0);
}


void rsRib() {
for (i=0;i<1;i++){make_stitch(KNIT);}do {for (i=0;i<1;i++){make_stitch(PURL);}
for (i=0;i<1;i++){make_stitch(KNIT);}}while(prev_row!=NULL && prev_row->count!=0);
}

void rib() {
rsRib();
prev_row=curr;curr=NULL;
wsRib();
}

int main(int argc, char* argv[]) {
int repeat;
struct stitch* first_stitch;
make_stitch(CO);
int i;
for (i = 1; i < 7; i++) {
make_stitch(CO);
}
first_stitch=curr;
for(repeat=0;repeat<5;repeat++){
prev_row=curr;curr=NULL;
rib();prev_row=curr;}first_stitch=first_stitch->next_row;
if (argc > 1) {
if (!strcmp(argv[1], "--row_count")) {curr=first_stitch;i=0; while(curr!=NULL){i++; curr=curr->next_row;}printf("This pattern has %d rows.\n",i);}
if (!strcmp(argv[1], "--stitch_count")) {curr=first_stitch;if(argc > 2){repeat=atoi(argv[2]);i=1;while(curr->next_row!=NULL && i < repeat){i++;curr=curr->next_row;}}repeat=i;i=0;if(curr->next!=NULL){while(curr!=NULL){i++;curr=curr->next;}}else{i=curr->count;}printf("Row %d of this pattern has %d stitches.\n",repeat,i);}
if (!strcmp(argv[1], "--print_chart")) {curr=first_stitch;while(curr->next_row!=NULL){curr=curr->next_row;}first_stitch=curr;while(first_stitch!=NULL){
if(curr->next!=NULL){while(curr!=NULL){print_stitch_symbol(curr->type,1);curr=curr->next;}}else{while(curr!=NULL){print_stitch_symbol(curr->type,0);curr=curr->prev;}}printf("\n");first_stitch=first_stitch->prev_row;curr=first_stitch;}}
}}
