{ open Parser }

rule token = parse
  [' ' '\t' '\r' ] { token lexbuf } (* Whitespace *)
| "Note: "     { comment lexbuf }   (* Comments *)
| '\n'     { EOL }
| '('      { LPAREN }
| ')'      { RPAREN }
| ','      { COMMA }
| ':'      { COLON }
| '*'      { STAR }
| 'k'      { KNIT }
| 'p'      { PURL }
| "inc"    { INC }
| "dec"    { DEC }
| "CO"     { CO }
| "BO"     { BO }
| "Row"    { ROW }
| "Work"   { WORK }
| "times"  { TIMES }
| "until"  { UNTIL }
| "stitches remain" { REMAIN }
| "Stitch Pattern" { STPATT }
| "repeat" { REPEAT }
| ['0'-'9']+ as lxm { LITERAL(int_of_string lxm) }
| ['a'-'j' 'l'-'o' 'q'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']*
      as lxm { ID(lxm) }
| eof { EOF }
| _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
  "\n" { token lexbuf }
| _    { comment lexbuf }
