#include <stdio.h>
#include <stdlib.h>

enum stitch_type { KNIT, PURL, INCREASE, DECREASE, CO };

struct stitch {
  int right_side;
  int count;
  enum stitch_type type;
  struct stitch* next;
  struct stitch* prev;
  struct stitch* next_row;
  struct stitch* prev_row;
};

struct stitch* make_stitch(
    enum stitch_type type, struct stitch* prev, struct stitch* prev_row) {
  struct stitch* new_stitch = (struct stitch*) malloc(sizeof(struct stitch));
  new_stitch->type = type;
  new_stitch->prev = prev;
  int count = 0;
  if (prev != NULL) {
    prev->next = new_stitch;
    count = prev->count + 1;
  }
  new_stitch->count = count;
  printf("%d\t", count);
  new_stitch->prev_row = prev_row;
  if (prev_row != NULL) {
    prev_row->next_row = new_stitch;
  }

  if (type == INCREASE) {
    printf("INCREASE\t");
    new_stitch->next = (struct stitch*) malloc(sizeof(struct stitch));
    new_stitch->next->prev = new_stitch;
    new_stitch = new_stitch->next;
    new_stitch->type = INCREASE;
    new_stitch->count = count + 1;
    new_stitch->prev_row = prev_row;
  }

  return new_stitch;
}


int main(int argc, char* argv[]) {
  struct stitch* curr = make_stitch(CO, NULL, NULL);
  struct stitch* first_stitch = curr;
  int i, count = 5;
  if (argc > 1) {
      count = atoi(argv[1]);
  }
  for (i = 1; i < count; i++) {
    curr = make_stitch(CO, curr, NULL);
  }

  for (i = 0; i < count; i++) {
    printf("\n");
    struct stitch* prev_row = curr;
    curr = NULL;
    while (prev_row != NULL) {
      printf("p %d ", prev_row->count);
      if (prev_row->count != 2) {
        curr = make_stitch(KNIT, curr, prev_row);
      } else {
        curr =  make_stitch(INCREASE, curr, prev_row);
      }
      prev_row = prev_row->prev;
    }
  }

  while (curr != NULL) {
    printf("%d", curr->count);
    if (curr->prev != NULL) {
      curr = curr->prev;
    } else if (curr->prev_row != NULL) {
      printf("\n");
      curr = curr->prev_row;
    } else {
      curr = NULL;
    }
  }

  int row_count = 0;
  curr = first_stitch;
  while (curr->next_row != NULL) {
    curr = curr->next_row;
    row_count++;
  }
  printf("\n\nThere are %d rows.\n\n", row_count);
}
